# Accessing the Raspberry Pi Camera with OpenCV and PythonPython

# import the necessary packages
# import camera
from picamera.array import PiRGBArray
from picamera import PiCamera
import time
import cv2

# import networking
import socket  

# configuration data 
camera_port = 12345
camera_timeout = 60000          # Time in ms

# setup camera socket

s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)           # Create a socket object
host = ''    # Get local machine name
print "host : ", host
s.bind((host, camera_port))     # Bind to the port

 
# initialize the camera and grab a reference to the raw camera capture
camera = PiCamera()
camera.resolution = (640, 480)
camera.framerate = 32
rawCapture = PiRGBArray(camera, size=(640, 480))
 
# allow the camera to warmup
time.sleep(0.1)
 
    
s.listen(1)
while True:
    c, addr = s.accept()         # Establish connection with client.
    print 'Got connection from', addr

    # capture frames from the camera
    for frame in camera.capture_continuous(rawCapture, format="bgr", use_video_port=True):
        
        # grab the raw NumPy array representing the image, then initialize the timestamp
        # and occupied/unoccupied text
        image = frame.array
     
        # show the frame
        cv2.imshow("Frame", image)
        key = cv2.waitKey(1) & 0xFF
        
        # send frame
        print("image", image.shape)
        image = image.flatten()
        data = image.tostring()
        s.send(data)
     
        # clear the stream in preparation for the next frame
        rawCapture.truncate(0)
     
        # if the `q` key was pressed, break from the loop
        if key == ord("q") or s.__getattribute__():
            break
    c.close()
    break  