from src.managers.sensor_manager import SensorManager
from src.managers.setup_motor_manager import SetupMotorManager

class Robot(object):
    
    sensor_manager = SensorManager()
    drive_manager = SetupMotorManager(sensor_manager)
    
    # configuration data
    # direction data
    GripperTopDirection = 0     # Large gear turns Clockwise
    GripperBotDirection = 0 
    
    GimbalPitchAxis = 0         # Is the axis inverted
    GimbalTopDirection = 0      # Unwinding
    GimbalBotDirection = 0
    
    GimbalYawAxis = 0
    GimbalLeftDirection = 0
    GimbalRightDirection = 0
    
    LeadScrewDirection = 0      # Extending
    
    # pot data
    GimbalTopMax = 0            # Fully released
    GimbalTopMin = 0            # Fully tightened
    GimbalBotMax = 0
    GimbalBotMin = 0
    GimbalLeftMax = 0
    gimbalLeftMin = 0
    GimbalRightMax = 0
    GimbalRightMin = 0
    
    GripperTopOpen = 500
    GripperBotOpen = 500
    
    
    # state data
    setTopGripper = ""
    setBotGripper = ""
    setLeadScrew = ""
    setPitch = 0
    setYaw = 0
    
    def __init__(self):
        if self.sensor_manager.topClawMotorPot.readValue() > self.GripperTopOpen:
            self.setTopGripper = "open"
        else:
            self.setTopGripper = "closed"
        if self.sensor_manager.botClawMotorPot.readValue() > self.GripperBotOpen:
            self.setBotGripper = "open"
        else:
            self.setBotGripper = "closed"
    
    def setGripper(self, half, state):
        if (half == "TOP"):
            self.setTopGripper = state
        else:
            self.setBotGripper = state
    
    def stateGripper(self, half):
        if (half == "TOP"):
            return self.setTopGripper
        else:
            return self.setBotGripper
    
    def potGripper(self, half):
        if (half == "TOP"):
            return self.sensor_manager.topClawMotorPot.readValue()
        else:
            return self.sensor_manager.botClawMotorPot.readValue()
        
    def driveRobot(self):
        if self.sensor_manager.topClawMotorPot.readValue() > self.GripperTopOpen and self.setTopGripper == "closed":
            self.drive_manager.driveClaws("TOP", self.GripperTopDirection)
        if self.sensor_manager.topClawMotorPot.readValue() < self.GripperTopOpen and self.setTopGripper == "open":
            self.drive_manager.driveClaws("TOP", self.GripperTopDirection)
        if self.sensor_manager.topClawMotorPot.readValue() < self.GripperTopOpen and self.setTopGripper == "closed":
            self.drive_manager.stopClaws("TOP")
        if self.sensor_manager.topClawMotorPot.readValue() > self.GripperTopOpen and self.setTopGripper == "open":
            self.drive_manager.stopClaws("TOP")
            
        if self.sensor_manager.botClawMotorPot.readValue() > self.GripperBotOpen and self.setBotGripper == "closed":
            self.drive_manager.driveClaws("BOT", self.GripperBotDirection)
        if self.sensor_manager.botClawMotorPot.readValue() < self.GripperBotOpen and self.setBotGripper == "open":
            self.drive_manager.driveClaws("BOT", self.GripperBotDirection)
        if self.sensor_manager.botClawMotorPot.readValue() < self.GripperBotOpen and self.setBotGripper == "closed":
            self.drive_manager.stopClaws("BOT")
        if self.sensor_manager.botClawMotorPot.readValue() > self.GripperBotOpen and self.setBotGripper == "open":
            self.drive_manager.stopClaws("BOT")
        
        