#Imports
import termios, fcntl, sys, os
from time import sleep
sys.path.append(os.path.join(os.path.dirname(__file__), ".."));
import src
import RPi.GPIO as GPIO

from managers.sensor_manager import SensorManager
from managers.setup_motor_manager import SetupMotorManager

sensor_manager = SensorManager()
drive_manager = SetupMotorManager(sensor_manager)

# Functions
def clear():
    os.system('cls' if os.name == 'nt' else 'clear')

def getKey():
    c = 0  
    i = 0
    # The recommended minimum is 1000
    while(c == 0 and i < 1200):
        try:
            c = sys.stdin.read(1)
            print "Got character", repr(c)
        except IOError: pass
        i = i + 1
    return c



#Main code
fd = sys.stdin.fileno()

oldterm = termios.tcgetattr(fd)
newattr = termios.tcgetattr(fd)
newattr[3] = newattr[3] & ~termios.ICANON & ~termios.ECHO
termios.tcsetattr(fd, termios.TCSANOW, newattr)

oldflags = fcntl.fcntl(fd, fcntl.F_GETFL)
fcntl.fcntl(fd, fcntl.F_SETFL, oldflags | os.O_NONBLOCK)

key = 0
motor = drive_manager.gimbleMotorPitch1
GimbalTopDirection = "CCW"
GimbalPitchAxis = 0


while (key != '\n'):
    key = getKey()
    if(key == '\x1b'):
        print("hit ESC")
        drive_manager.stop()
    if(key == "\t"):
        if(GimbalTopDirection == "CW"):
            GimbalTopDirection = "CCW"
            print("Motor is now normal")
        else:
            GimbalTopDirection = "CW"
            print("Motor is now reversed")
    if(key == "/"):
        drive_manager.stopGimbal()
        if(GimbalPitchAxis == 1):
            GimbalPitchAxis = 0
            print("Axis is now normal")
            motor = drive_manager.gimbleMotorPitch1
        else:
            GimbalPitchAxis = 1
            print("Axis is now flipped")
            motor = drive_manager.gimbleMotorPitch2
    
    if(key == ' '):
        print("Drive")
        motor.write(GimbalTopDirection, 100)
    if(key == 0):
        motor.stop()



termios.tcsetattr(fd, termios.TCSAFLUSH, oldterm)
fcntl.fcntl(fd, fcntl.F_SETFL, oldflags)
clear()
